open OUnit2
open Interp2

(* A few test cases *)
let tests = [
  "int"  >:: (fun _ -> assert_equal (Int 22) (eval (Int 22)));
  "add"  >:: (fun _ -> assert_equal (Int 22) (eval (Add(Int 11,Int 11))));
  "adds" >:: (fun _ -> assert_equal (Int 22) (eval (Add(Add(Int 10, Int 1),Add(Int 5, Int 6)))));
  "let"  >:: (fun _ -> assert_equal (Int 22) (eval (Let("x",Int 22,Var "x"))));
  "lets" >:: (fun _ -> assert_equal (Int 22) (eval (Let("x",Int 0,Let("x",Int 22,Var "x")))));
]

let _ = run_test_tt_main ("interp2 suite" >::: tests)

